Attribute VB_Name = "Module1"

Public Declare Function Ellipse Lib "gdi32" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Declare Function CallWindowProc Lib "user32" Alias _
"CallWindowProcA" (ByVal lpPrevWndFunc As Long, _
   ByVal hwnd As Long, ByVal Msg As Long, _
   ByVal wParam As Long, ByVal lParam As Long) As Long

Declare Function SetWindowLong Lib "user32" Alias _
"SetWindowLongA" (ByVal hwnd As Long, _
ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_WNDPROC = -4
Private Const WM_DRAWITEM = &H2B
Global lpPrevWndProc As Long
Global gHW As Long

Private Declare Sub CopyMemory Lib "kernel32" _
   Alias "RtlMoveMemory" _
   (hpvDest As Any, _
    hpvSource As Any, _
    ByVal cbCopy As Long)
    
Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
    

Public Const DFCS_SCROLLSIZEGRIP = &H8         'Size grip
Public Const DFCS_SCROLLSIZEGRIPRIGHT = &H10   'Size grip in
Public Const DFC_SCROLL = 3
Public Declare Function DrawFrameControl Lib "user32" (ByVal _
         hDC&, lpRect As RECT, ByVal un1 As Long, ByVal un2 As Long) _
         As Boolean

Private Declare Function DrawEdge Lib "user32" (ByVal hDC As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
Private Const BDR_INNER = &HC
Private Const BDR_OUTER = &H3
Private Const BDR_RAISED = &H5
Private Const BDR_RAISEDINNER = &H4
Private Const BDR_RAISEDOUTER = &H1
Private Const BDR_SUNKEN = &HA
Private Const BDR_SUNKENINNER = &H8
Private Const BDR_SUNKENOUTER = &H2
Private Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)
Private Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Private Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
Private Const BF_ADJUST = &H2000   ' Calculate the space left over.
Private Const BF_BOTTOM = &H8
Private Const BF_DIAGONAL = &H10
Private Const BF_FLAT = &H4000     ' For flat rather than 3-D borders.
Private Const BF_LEFT = &H1
Private Const BF_MIDDLE = &H800    ' Fill in the middle.
Private Const BF_MONO = &H8000     ' For monochrome borders.
Private Const BF_RIGHT = &H4
Private Const BF_SOFT = &H1000     ' Use for softer buttons.
Private Const BF_TOP = &H2
Private Const BF_TOPLEFT = (BF_TOP Or BF_LEFT)
Private Const BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)
Private Const BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)
Private Const BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT)
Private Const BF_DIAGONAL_ENDBOTTOMLEFT = (BF_DIAGONAL Or BF_BOTTOM Or BF_LEFT)
Private Const BF_DIAGONAL_ENDBOTTOMRIGHT = (BF_DIAGONAL Or BF_BOTTOM Or BF_RIGHT)
Private Const BF_DIAGONAL_ENDTOPLEFT = (BF_DIAGONAL Or BF_TOP Or BF_LEFT)
Private Const BF_DIAGONAL_ENDTOPRIGHT = (BF_DIAGONAL Or BF_TOP Or BF_RIGHT)
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)

Private Type DRAWITEMSTRUCT
        CtlType As Long
        CtlID As Long
        itemID As Long
        itemAction As Long
        itemState As Long
        hwndItem As Long
        hDC As Long
        rcItem As RECT
        itemData As Long
End Type
Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function DrawState Lib "user32" Alias "DrawStateA" (ByVal hDC As Long, ByVal hBrush As Long, ByVal lpDrawStateProc As Long, ByVal lParam As Long, ByVal wParam As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal n3 As Long, ByVal n4 As Long, ByVal un As Long) As Long
Public Const DST_COMPLEX = &H0&
Public Const DST_TEXT = &H1&
Public Const DST_PREFIXTEXT = &H2&
Public Const DST_ICON = &H3&
Public Const DST_BITMAP = &H4&

' /* State type */
Public Const DSS_NORMAL = &H0&
Public Const DSS_UNION = &H10& ' Dither
Public Const DSS_DISABLED = &H20&
Public Const DSS_MONO = &H80& ' Draw in colour of brush specified in hBrush
Public Const DSS_RIGHT = &H8000&

Private Type BITMAP '14 bytes
        bmType As Long
        bmWidth As Long
        bmHeight As Long
        bmWidthBytes As Long
        bmPlanes As Integer
        bmBitsPixel As Integer
        bmBits As Long
End Type

Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Public Const COLOR_BTNFACE = 15
Public Declare Function InflateRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Public Const HTBOTTOMRIGHT = 17
Public Type POINTS
        X  As Integer
        Y  As Integer
End Type
Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Type POINTAPI
        X As Long
        Y As Long
End Type
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long
Public Const WM_NCLBUTTONDOWN = &HA1

Public Sub Hook()
   lpPrevWndProc = SetWindowLong(gHW, GWL_WNDPROC, _
   AddressOf WindowProc)
End Sub

Public Sub Unhook()
   Dim temp As Long
   temp = SetWindowLong(gHW, GWL_WNDPROC, _
   lpPrevWndProc)
End Sub

Function WindowProc(ByVal hw As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   'Debug.Print "Message: "; hw, uMsg, wParam, lParam
'On Error Resume Next

If uMsg = WM_DRAWITEM Then
    Dim tDis As DRAWITEMSTRUCT
    Dim Frct As RECT
    Dim hBr As Long
    
    CopyMemory tDis, ByVal lParam, Len(tDis)
    
    Dim TmpCom As Object
    
    For Each TmpCom In Form1
        If TypeOf TmpCom Is CommandButton Then
            If TmpCom.hwnd = tDis.hwndItem Then
                Exit For
            End If
        End If
    Next
    
    hBr = CreateSolidBrush(GetSysColor(COLOR_BTNFACE))
    FillRect tDis.hDC, tDis.rcItem, hBr
    DeleteObject hBr
    
    Dim BitM As BITMAP
    Dim xtmp, ytmp As Long
    
    GetObject TmpCom.Picture.Handle, LenB(BitM), BitM
    'Debug.Print TmpCom.Picture.Handle
    'xtmp = Int((tDis.rcItem.Right / 2) - (BitM.bmWidth / 2))
    'ytmp = Int((tDis.rcItem.Bottom / 2) - (BitM.bmHeight / 2))
    xtmp = Int((tDis.rcItem.Right / 2) - 8)
    ytmp = Int((tDis.rcItem.Bottom / 2) - 8)
    
    If tDis.itemState = 17 Then
        xtmp = xtmp + 1
        ytmp = ytmp + 1
    End If
    
    DrawState tDis.hDC, 0, 0, TmpCom.Picture.Handle, 0, _
    xtmp, ytmp, _
    BitM.bmWidth, BitM.bmHeight, _
    DST_ICON
    
    If tDis.itemState = 17 Then
        DrawEdge tDis.hDC, tDis.rcItem, BDR_SUNKENOUTER, BF_RECT
    Else
        DrawEdge tDis.hDC, tDis.rcItem, BDR_RAISEDINNER, BF_RECT
    End If
    
    Exit Function
End If


    WindowProc = CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam)
End Function


Public Function tDrawEdge(tHdc As Long, xx As Long, yy As Long, wWidth As Long, hHeight As Long, Optional JustFrame As Boolean = False)
Dim TmpRect As RECT

TmpRect.Left = xx
TmpRect.Top = yy
TmpRect.Right = xx + wWidth
TmpRect.Bottom = yy + hHeight

DrawEdge tHdc, TmpRect, BDR_SUNKENOUTER, BF_RECT

TmpRect.Left = xx + wWidth - hHeight
TmpRect.Right = TmpRect.Left + hHeight

InflateRect TmpRect, -1, -1

If Not JustFrame Then
    DrawFrameControl tHdc, TmpRect, DFC_SCROLL, DFCS_SCROLLSIZEGRIP
End If
End Function
